#DNS collector


# Collect joblogs of QTOBD<instanceName>
# Network verifier plugin
#
#
# list contents of /qibm/userdata/os400/DNS  
# do not include _DYN
#
# Run healthcheck
# chkprdopt option  or 31
# prehealthcheck
#

# TEST TO SEE IF JDK 6 is INSTALLED.  This is required for FTPing to ECUREP
FTP_RESPONSE=""
EMAIL=""
DNS_SERVER=""
if test -e /qibm/proddata/java400/jdk6; then
echo "JDK 6.0 found"
echo "  "
export JDK6_PATH="/qibm/proddata/java400/jdk6/bin"
echo "Will this DNSCollector.zip file be uploaded to ecurep for a PMR? (This requires JDK 6.0) Y or N?"
read FTP_RESPONSE
echo "   "
elif test -e /QOpenSys/QIBM/ProdData/JavaVM/jdk60; then
echo "JDK 6.0 found"
echo "  "
export JDK6_PATH="/QOpenSys/QIBM/ProdData/JavaVM/jdk60/32bit/bin"
echo "Will this DNSCollector.zip file be uploaded to ecurep for a PMR? (This requires JDK 6.0) Y or N?"
read FTP_RESPONSE
echo "   "
fi

### Make FTP_RESPONSE uppercase
#if test ${FTP_RESPONSE} = "n"; then
#export FTP_RESPONSE='N'
#fi
#if test ${FTP_RESPONSE} = "y"; then 
#export FTP_RESPONSE='Y'
#fi     
if [ "$FTP_RESPONSE" = " " ] || [ -z "$FTP_RESPONSE" ]; then
export FTP_RESPONSE='N'
fi
                                                            
  
 
# If this will be FTPed to ecurep, then PMR and EMAIL need to be entered 
if test $(echo $FTP_RESPONSE | tr '[a-z]' '[A-Z]') = "Y"; then                                                                  
if test "${PMR}" = ""; then
echo "Please enter your PMR number in the following format (ppppp.bbb.ccc where p=PMR Number, b=branch id, c=country code NOTE: For US customers the country code should be 000):"
read PMR
fi

if test "${EMAIL}" = ""; then
echo "Please enter your e-mail address. We will send you a confirmation within 1 hour to let you know that the file has arrived successfully"
read EMAIL
fi
fi



# determine the OS version and then collects only the data specific to that version
RELEASE=`(uname -r) 2>/dev/null` || RELEASE=unknown
VERSION=`(uname -v) 2>/dev/null` || VERSION=unknown


# determines the current location

CURLOC=`(pwd) 2>/dev/null`

export DNS_SERVER=$1
header="*"
DATE=`(date "+%m-%d-%Y")`
#Initialize variables in loop in case customer end prog or breaks.
MYVAR=0
#Uninitialize variable for filecheck
unset filecheck
menucycle=true
DISPLAY=0
#Current DNS directory for V5R4 and up
DNS_dir=/qibm/userdata/os400/dns

header()
{
echo "****************************************************************************"
printf "%30s %30s\n" "DNS Server list:" "Status:";
echo "****************************************************************************"
}

footer()
{
echo "           ------------------------------------------------------- "
printf "%45s\n" "$MYVAR DNS server(s) listed."
echo "      "

}

rename()
{
for rfile in $(ls network*.*); 
do
if [ ${rfile: -4} != ".txt" ] && [ ${rfile: -4} != ".xml" ]
then
mv $rfile $rfile".txt";
printf "%10s %-30s %-20s %20s\n" ">>>>" "RENAMED $rfile" "--------------->" "$rfile.txt"
else
fi
done
}

checkok()
{   
   #Counting directory list
    MYVAR=`expr $MYVAR + 1`
    printf "%20s %-35s %-25s\n" "[ $MYVAR ]" $i "OK!";
    eval mydnslist$MYVAR="$i"
    unset filecheck                            
    #n=`expr $n + 1`
}

checkerror()
{
    #echo "${DNS_dir}/${i}"
    #Counting directory list
    MYVAR=`expr $MYVAR + 1`
    printf "%20s %-35s %-25s\n" "[ $MYVAR ]" $i "ERROR!";
    eval mydnslist$MYVAR="$i"
    unset filecheck
}

confcheck()
{
#Looping the DNS directory list
for i in $(ls $DNS_dir); do
#Skipping "_DYN" and "collectorfiles" folders as they are not part of the DNS list also no files list.
  if [ $i == "_DYN" ] || [ $i == "collectorfiles" ] || [ -f "$DNS_dir/$i" ]
  then
#Doing cleanup of previous collectorfiles.
   if [ $i == "collectorfiles" ]
      then 
        cd ${DNS_dir}
        rm -rf ./collectorfiles
        else
        fi
  else
      # Checks to see if file size is greater than zero and exists (-s).    
      if [ -s /qibm/userdata/os400/dns/${i}/named.conf ]
      then
        filecheck=true
      else
        unset filecheck
      fi

    if [ $filecheck ]
    then
    checkok

    else
    checkerror
      
    fi
  
  fi
done
}



#Adding the functions to create the header, body and footer for DNS list.
header
confcheck
footer

echo "Please enter the number that corresponds to the DNS server."

#else
#Loop that when DNS_SERVER is blank or incorrect entry it will continuously loop until correct DNS server selected.
#while [[ test "$DNS_SERVER" == "" ] || [ test ${DNS_SERVER%%.*} < 1 ]] ;
while test "$DNS_SERVER" == "" ;
do
read DNSLIST
#If mydnslist$DNSLIST is not valid it will return $DNS_SERVER="" (Blank)
eval DNS_SERVER="\$mydnslist$DNSLIST"
#This tells us if customer has already tried 3 incorrect attempts to select a menu option.
if [ $DISPLAY -gt 1 ]
then
#This now will display DNS list again and reset the loop and also reset the DNS list array.
MYVAR=0
header
confcheck
footer
DISPLAY=0
else
#DISPLAY=`expr $DISPLAY + 1`
fi


#Loop against until correct DNS server is selected.
#This function determines if DNS_SERVER string length is zero, this will only happen if no answer supplied or $mydnslist$DNSLIST is invalid like $mydnslist6 when 
#there are only 5 DNS instances. The second part determines if this is a integer and not decimals are allowed ( 2< /dev/null quiets any systemout messages.)
if [ "$DNS_SERVER" != "" ] && [ $DNSLIST -eq $DNSLIST 2> /dev/null ] && [ $DNSLIST -gt 0 ];

# These are unused functions I decided not to use since they are long and drawn out.
# if [ $DNSLIST -ne 0 -o $DNSLIST -eq 0 > /dev/null 2>&1 ] || [ -z "$DNS_SERVER" ] || 
# || [ $DNSLIST != $(echo $DNSLIST | awk '{print int($1+0.5)}') > /dev/null 2>&1 ];
#if [ -z "$DNS_SERVER" ] || [ "$DNSLIST" -ne 0 -o "$DNSLIST" -eq 0 > /dev/null 2>&1 ] || [ "$DNSLIST" != $(echo $DNSLIST | awk '{print int($1+0.5)}' > /dev/null 2>&1)  ]

then
echo "      "
#unset menucycle
break;
else
echo "    "
echo "'$DNSLIST' is an invalid option. Please try again or press 'F3' to exit program."
#We want to reset these variables if they are incorrect as the loop detects if DNS_SERVER and DNSLIST are truly lists of instances on the server.
DNS_SERVER=""
DNSLIST=""
DISPLAY=`expr $DISPLAY + 1`
echo "      "
continue;
fi
done
echo "    "
#fi
#done
#We need to run eval command to change the instance name to capitalized for better read out to customer.
eval echo "    SUCCESS! Located DNS instance $(echo $DNS_SERVER | tr '[a-z]' '[A-Z]'), continuing DNS collecting...."
echo "    "
mkdir -p /qibm/userdata/os400/DNS/collectorfiles/joblogs 2>/dev/null

# Redirect Errors to /QIBM/UserData/HTTPA/Admin/logs/httpAdminScriptErrors.txt
exec 2>/qibm/userdata/os400/DNS/collectorfiles/DNSCollectorScriptErrors.txt

touch -C 1252 /qibm/userdata/os400/DNS/collectorfiles/prehealthcheck.txt
touch -C 1252 /qibm/userdata/os400/DNS/collectorfiles/Dspptf.txt
touch -C 1252 /qibm/userdata/os400/DNS/collectorfiles/chkprdopt31.txt
touch -C 1252 /qibm/userdata/os400/DNS/collectorfiles/dspsfwrsc.txt
touch -C 1252 /qibm/userdata/os400/DNS/collectorfiles/wrkactjob.txt
touch -C 1252 /qibm/userdata/os400/DNS/collectorfiles/wrksysval.txt
touch -C 1252 /qibm/userdata/os400/DNS/collectorfiles/cfgtcpopt10.txt
touch -C 1252 /qibm/userdata/os400/DNS/collectorfiles/cfgtcpopt12.txt
touch -C 1252 /qibm/userdata/os400/DNS/collectorfiles/cfgtcpopt1.txt
touch -C 1252 /qibm/userdata/os400/DNS/collectorfiles/ServiceDBPorts.txt



echo "  "
echo "Step 1 of 6: Network Verifier and Pre-health check."
#Running plugin Network Verifier
cd /qibm/userdata/os400/DNS/collectorfiles
/QIBM/ProdData/OS/OSGi/templates/bin/areVerify.sh -network
 
/QIBM/ProdData/OS/OSGi/templates/bin/areVerify.sh -precheck > /qibm/userdata/os400/DNS/collectorfiles/prehealthcheck.txt
echo "   "
rename
echo "   "

echo "Step 2 of 6: Gathering PTF, WRKACTJOB, DSPSFWRSC, WRKSYSVAL"
#Spool out dspptf, dspsfwrsc, wrkactjob, wrksysval, wrksyssts to .txt files
system "DSPPTF" > /qibm/userdata/os400/DNS/collectorfiles/Dspptf.txt   
system dspsfwrsc > /qibm/userdata/os400/DNS/collectorfiles/dspsfwrsc.txt
system wrkactjob > /qibm/userdata/os400/DNS/collectorfiles/wrkactjob.txt
system wrksysval > /qibm/userdata/os400/DNS/collectorfiles/wrksysval.txt

echo "Step 3 of 6: Checking Product Options (CHKRPDOPT)"

if [ "$VERSION" = "5" ] && [ "$RELEASE" = "4" ]
then
	VRM="V5R4"
  system "CHKPRDOPT PRDID(5722SS1) OPTION(31) DETAIL(*FULL)" 2> /qibm/userdata/os400/DNS/collectorfiles/chkprdopt31.txt 
	
	
elif [ "$VERSION" = "6" ] && [ "$RELEASE" = "1" ]
then
	VRM="V6R1"
	system "CHKPRDOPT PRDID(5761SS1) OPTION(31) DETAIL(*FULL)" 2> /qibm/userdata/os400/DNS/collectorfiles/chkprdopt31.txt 

elif [ "$VERSION" = "7" ] && [ "$RELEASE" = "1" ]
then
	VRM="V7R1"
	system "CHKPRDOPT PRDID(5770SS1) OPTION(31) DETAIL(*FULL)" 2> /qibm/userdata/os400/DNS/collectorfiles/chkprdopt31.txt 

fi

echo "Step 4 of 6: COllecting TCP/IP Data"

#DISPLAY TCP CONFIGURATION
system "CPYTOIMPF FROMFILE(QUSRSYS/QATOChost hosts) TOSTMF('/qibm/userdata/os400/DNS/collectorfiles/cfgtcpopt10.txt') MBROPT(*REPLACE) RCDDLM(*CRLF) RMVBLANK(*BOTH) FLDDLM(*TAB)"
system "CPYTOIMPF FROMFILE(QUSRSYS/QATOCtcpip config) TOSTMF('/qibm/userdata/os400/DNS/collectorfiles/cfgtcpopt12.txt') MBROPT(*REPLACE) RCDDLM(*CRLF) RMVBLANK(*BOTH) FLDDLM(*TAB)"
system "CPYTOIMPF FROMFILE(QUSRSYS/QATOCIFC INTERFACES) TOSTMF('/qibm/userdata/os400/DNS/collectorfiles/cfgtcpOpt1.txt') MBROPT(*REPLACE) RCDDLM(*CRLF) RMVBLANK(*BOTH) FLDDLM(*TAB)"
system "CPYTOIMPF FROMFILE(QUSRSYS/QATOCPS SERVICES) TOSTMF('/qibm/userdata/os400/DNS/collectorfiles/ServiceDBPorts.txt') MBROPT(*REPLACE) RCDDLM(*CRLF) RMVBLANK(*BOTH) FLDDLM(*TAB)"



echo "Step 5 of 6: Gathering joblogs for QTOBD${DNS_SERVER}"

#####Gather Joblogs for the active DNS server jobs

ps -lu QTCP -o JOBNUM,JOBNAME,STIME,STATUS,JOBID | grep -i ${DNS_SERVER} > /qibm/userdata/os400/DNS/collectorfiles/ActiveDNSJobs.txt


cat /qibm/userdata/os400/DNS/collectorfiles/ActiveDNSJobs.txt | cut -c 49-77 |
while read line
do
echo $line > /qibm/userdata/os400/DNS/collectorfiles/JobName.txt
JOBNUMBER=`cut -c 1-6 /qibm/userdata/os400/DNS/collectorfiles/JobName.txt` > /qibm/userdata/os400/DNS/collectorfiles/JobNumber.txt
system "DSPJOBLOG JOB($line)" >> /qibm/userdata/os400/DNS/collectorfiles/joblogs/${DNS_SERVER}Joblog${JOBNUMBER}.txt

done

rm /qibm/userdata/os400/DNS/collectorfiles/JobName.txt
rm /qibm/userdata/os400/DNS/collectorfiles/JobNumber.txt

#Gather QPJOBLOGs for OUTQ status with today's date
system "CRTPF FILE(QGPL/JOBLOGS) RCDLEN(150) MAXMBRS(*NOMAX) SIZE(*NOMAX)"

ps -tlu QTCP -o STIME,JOBNAME,STATUS,JOBID | grep -i  ${DNS_SERVER}  | grep $DATE >  /qibm/userdata/os400/DNS/collectorfiles/OUTQDNSJobs.txt

#This cuts out the fully qualified job name of the outq jobs
cat  /qibm/userdata/os400/DNS/collectorfiles/OUTQDNSJobs.txt | cut -c 42-71 |

while read line
do
echo $line > /qibm/userdata/os400/DNS/collectorfiles/JobName.txt
JOBNUMBER=`cut -c 1-6 /qibm/userdata/os400/DNS/collectorfiles/JobName.txt`  #This cuts out just the number of the Full job name
echo ${JOBNUMBER}
system "CPYSPLF FILE(QPJOBLOG) TOFILE(QGPL/JOBLOGS) JOB($line) TOMBR(${DNS_SERVER})"
touch -C 1252 /qibm/userdata/os400/DNS/collectorfiles/joblogs/${DNS_SERVER}Joblog${JOBNUMBER}.txt
system "CPYTOIMPF FROMFILE(QGPL/JOBLOGS ${DNS_SERVER}) TOSTMF('/qibm/userdata/os400/DNS/collectorfiles/joblogs/${DNS_SERVER}Joblog${JOBNUMBER}.txt')    MBROPT(*REPLACE) TOCCSID(1252) RCDDLM(*CRLF)"
done

system "DLTF FILE(QGPL/JOBLOGS)"
rm  /qibm/userdata/os400/DNS/collectorfiles/JobName.txt
rm  /qibm/userdata/os400/DNS/collectorfiles/OUTQDNSJobs.txt



eval file="${DNS_SERVER}.$(date +%m%d-%H%M%).DNSCollect.zip"
echo "Step 6 of 6: Finishing collecting." 
echo "             Your file location: ${CURLOC}/${file} "
echo "   "
jar -cvf ${CURLOC}/${file} \
/qibm/userdata/os400/DNS/${DNS_SERVER} \
/qibm/userdata/os400/DNS/_DYN \
/qibm/userdata/os400/DNS/collectorfiles \

###If this is to be FTPd to ecurep

# TESTS to see if file needs to be FTPed, then tests to see if it has the required JDK 6.0 to do the FTP
# This script checks response it converts lower case to upper case "Y".
if test $(echo $FTP_RESPONSE | tr '[a-z]' '[A-Z]') = "Y"; then

if test -e ${CURLOC}/${file}; then
if test -e ${CURLOC}/ibmsdduu.jar; then
echo "We will now attempt to send it to service for analysis..."

#Use -id=${PMR//,/.} to replace any commas with periods.
${JDK6_PATH}/java  -cp .:$CURLOC/ibmsdduu.jar ibmsdduu.cmd -email=${EMAIL} -pmr -id=${PMR//,/.} -compress -encrypt ${CURLOC}/${file}

else
echo "      "
echo ">>>>>>>>>>>>>>>   SORRY, unable to send the file.   "  
echo ">>>>>>>>>>>>>>>   Please send the ${CURLOC}/${file} to this website:   "
echo ">>>>>>>>>>>>>>>   http://www.ecurep.ibm.com/app/upload   "
echo " "
fi
else
echo " "
echo ">>>>>>>>>>>>>>>   Sorry, there is a problem with the jar function.   "   
echo ">>>>>>>>>>>>>>>   Unable to create the ${file} file.   "
echo "  "
fi
else
echo "  "
echo ">>>>>>>>>>>>>>>   Please send the ${CURLOC}/${file} to this website:   "
echo ">>>>>>>>>>>>>>>   http://www.ecurep.ibm.com/app/upload   "
echo "   "
fi

# Since the opposite of the answer to send FTP is "N" we don't need to reiterate the if then else function previously given.
#echo "check if FTP_RESPONSE is set to N"

#if test $(echo $FTP_RESPONSE | tr '[a-z]' '[A-Z]') = "N"; then
#if test -e ${CURLOC}/DNSCollector.zip; then
#echo "Please send the ${CURLOC}/DNSCollector.zip to this website:  http://www.ecurep.ibm.com/app/upload"
#else
#echo "There is a problem with the jar function, unable to create the ${CURLOC}/DNSCollector.zip file"
#fi
#fi



